From ade143667509b1bdb73a288cc57fcb44cae4d297 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Mon, 14 Mar 2022 21:29:50 +0100
Subject: [PATCH] debian: sync bullseye packaging with upstream debian.org
 (#62756)

---
 debian-bullseye/changelog            | 14 ++++++++++++++
 debian-bullseye/compat               |  1 -
 debian-bullseye/control              | 10 ++++------
 debian-bullseye/files                |  1 -
 debian-bullseye/php5-lasso.install   |  3 ---
 debian-bullseye/php5-lasso.postinst  |  7 -------
 debian-bullseye/php5-lasso.prerm     |  7 -------
 debian-bullseye/php5-lasso.substvars |  4 ----
 debian-bullseye/rules                |  2 +-
 9 files changed, 19 insertions(+), 30 deletions(-)
 delete mode 100644 debian-bullseye/compat
 delete mode 100644 debian-bullseye/files
 delete mode 100644 debian-bullseye/php5-lasso.install
 delete mode 100644 debian-bullseye/php5-lasso.postinst
 delete mode 100644 debian-bullseye/php5-lasso.prerm
 delete mode 100644 debian-bullseye/php5-lasso.substvars

diff --git a/debian-bullseye/changelog b/debian-bullseye/changelog
index d3433974..6e5a2344 100644
--- a/debian-bullseye/changelog
+++ b/debian-bullseye/changelog
@@ -1,3 +1,17 @@
+lasso (2.7.0-3) unstable; urgency=medium
+
+  * d/control, d/compat: switch to debhelper-compat, remove compat file.
+  * d/control: remove ancient X-Python3-Version field.
+  * d/control: update homepage to https.
+  * d/control: add ${misc:Depends} to liblasso3-dev.
+  * d/control: remove useless dh-autoreconf build dependency.
+  * d/control: update standards-version to 4.6.0.
+  * d/php5-lasso.*: remove files for delete PHP package.
+  * d/liblasso-java.*: remove files for deleted Java package.
+  * d/rules: use dh_prep instead of dh_clean -k.
+
+ -- Frederic Peters <fpeters@debian.org>  Tue, 08 Mar 2022 08:17:20 +0100
+
 lasso (2.7.0-2) unstable; urgency=medium
 
   * debian/rules: introduce build-arch/build-indep targets.
diff --git a/debian-bullseye/compat b/debian-bullseye/compat
deleted file mode 100644
index f599e28b..00000000
--- a/debian-bullseye/compat
+++ /dev/null
@@ -1 +0,0 @@
-10
diff --git a/debian-bullseye/control b/debian-bullseye/control
index e55606b4..4c14f778 100644
--- a/debian-bullseye/control
+++ b/debian-bullseye/control
@@ -2,9 +2,8 @@ Source: lasso
 Priority: optional
 Section: libs
 Maintainer: Frederic Peters <fpeters@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 12),
         dh-python,
-        dh-autoreconf,
         gtk-doc-tools,
         libxml2-dev,
         libxslt1-dev,
@@ -16,14 +15,13 @@ Build-Depends: debhelper (>= 9),
         python3-lxml,
         python3-six,
         chrpath
-Standards-Version: 4.4
-X-Python3-Version: >= 3.4
-Homepage: http://lasso.entrouvert.org
+Standards-Version: 4.6.0
+Homepage: https://lasso.entrouvert.org
 
 Package: liblasso3-dev
 Section: libdevel
 Architecture: any
-Depends: liblasso3 (= ${binary:Version}), libxml2-dev, libxmlsec1-dev, libglib2.0-dev
+Depends: liblasso3 (= ${binary:Version}), libxml2-dev, libxmlsec1-dev, libglib2.0-dev, ${misc:Depends}
 Provides: liblasso-dev
 Conflicts: liblasso-dev, liblasso0, liblasso1
 Description: Library for Liberty Alliance and SAML protocols - development kit
diff --git a/debian-bullseye/files b/debian-bullseye/files
deleted file mode 100644
index 82adcc08..00000000
--- a/debian-bullseye/files
+++ /dev/null
@@ -1 +0,0 @@
-lasso_2.7.0-2_source.buildinfo libs optional
diff --git a/debian-bullseye/php5-lasso.install b/debian-bullseye/php5-lasso.install
deleted file mode 100644
index 61607e59..00000000
--- a/debian-bullseye/php5-lasso.install
+++ /dev/null
@@ -1,3 +0,0 @@
-debian/tmp/etc/php5/
-debian/tmp/usr/share/php/
-debian/tmp/usr/lib/php5/*/lasso.so
diff --git a/debian-bullseye/php5-lasso.postinst b/debian-bullseye/php5-lasso.postinst
deleted file mode 100644
index 7fc54e5b..00000000
--- a/debian-bullseye/php5-lasso.postinst
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/sh -e
-
-if [ "$1" = "configure" ]; then
-   php5enmod lasso
-fi
-
-#DEBHELPER#
diff --git a/debian-bullseye/php5-lasso.prerm b/debian-bullseye/php5-lasso.prerm
deleted file mode 100644
index c12f5a40..00000000
--- a/debian-bullseye/php5-lasso.prerm
+++ /dev/null
@@ -1,7 +0,0 @@
-#! /bin/sh -e
-
-if [ "$1" = "remove" ]; then
-   php5dismod lasso
-fi
-
-#DEBHELPER#
diff --git a/debian-bullseye/php5-lasso.substvars b/debian-bullseye/php5-lasso.substvars
deleted file mode 100644
index 3e2e8040..00000000
--- a/debian-bullseye/php5-lasso.substvars
+++ /dev/null
@@ -1,4 +0,0 @@
-shlibs:Depends=libc6 (>= 2.2.5), libglib2.0-0 (>= 2.41.1), liblasso3 (>= 2.5.0), libssl1.0.2 (>= 1.0.2d), libxml2 (>= 2.7.4), libxmlsec1 (>= 1.2.20), libxmlsec1-openssl (>= 1.2.20), libxslt1.1 (>= 1.1.25), zlib1g (>= 1:1.1.4)
-php:Depends=phpapi-20131226
-misc:Depends=
-misc:Pre-Depends=
diff --git a/debian-bullseye/rules b/debian-bullseye/rules
index 9945162b..8018e122 100755
--- a/debian-bullseye/rules
+++ b/debian-bullseye/rules
@@ -89,7 +89,7 @@ clean:
 install-arch: build-arch
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 	dh_installdirs
 
 	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp \
-- 
2.35.1